CF731C Socks

CF731C Socks

洛谷评测传送门

题目描述

Arseniy is already grown-up and independent. His mother decided to leave him alone for mm days and left on a vacation. She have prepared a lot of food, left some money and washed all Arseniy's clothes.

Ten minutes before her leave she realized that it would be also useful to prepare instruction of which particular clothes to wear on each of the days she will be absent. Arseniy's family is a bit weird so all the clothes is enumerated. For example, each of Arseniy's nn socks is assigned a unique integer from 11 to nn . Thus, the only thing his mother had to do was to write down two integers l_{i}l**i and r_{i}r**i for each of the days — the indices of socks to wear on the day ii (obviously, l_{i}l**i stands for the left foot and r_{i}r**i for the right). Each sock is painted in one of kk colors.

When mother already left Arseniy noticed that according to instruction he would wear the socks of different colors on some days. Of course, that is a terrible mistake cause by a rush. Arseniy is a smart boy, and, by some magical coincidence, he posses kk jars with the paint — one for each of kk colors.

Arseniy wants to repaint some of the socks in such a way, that for each of mm days he can follow the mother's instructions and wear the socks of the same color. As he is going to be very busy these days he will have no time to change the colors of any socks so he has to finalize the colors now.

The new computer game Bota-3 was just realised and Arseniy can't wait to play it. What is the minimum number of socks that need their color to be changed in order to make it possible to follow mother's instructions and wear the socks of the same color during each of mm days.

输入格式

The first line of input contains three integers nn , mm and kk ( 2<=n<=2000002<=n<=200000 , 0<=m<=2000000<=m<=200000 , 1<=k<=2000001<=k<=200000 ) — the number of socks, the number of days and the number of available colors respectively.

The second line contain nn integers c_{1}c1 , c_{2}c2 , ..., c_{n}c**n ( 1<=c_{i}<=k1<=c**i<=k ) — current colors of Arseniy's socks.

Each of the following mm lines contains two integers l_{i}l**i and r_{i}r**i ( 1<=l_{i},r_{i}<=n1<=l**i,r**i<=n , l_{i}≠r_{i}l**ir**i ) — indices of socks which Arseniy should wear during the ii -th day.

输出格式

Print one integer — the minimum number of socks that should have their colors changed in order to be able to obey the instructions and not make people laugh from watching the socks of different colors.

题意翻译

有n只袜子,k种颜色,在m天中,问最少修改几只袜子的颜色,可以使每天穿的袜子左右两只都同颜色。

输入输出样例

输入 #1复制

输出 #1复制

输入 #2复制

输出 #2复制

说明/提示

In the first sample, Arseniy can repaint the first and the third socks to the second color.

In the second sample, there is no need to change any colors.

题解:

2019.11.5模拟赛95分场

题目翻译还挺好的,可以看一下。

我们发现,如果有一只袜子需要在(m)天中的多天出现,那么显然这只袜子要与所有和它配对的袜子颜色一样。

以此联想,我发现:这个关联关系是一张图,图上的节点就是袜子的编号,图的边表示这两只袜子要颜色一样。

那么我们发现,对于这张图的每一个连通块来讲,它的颜色必须是全部一样的。那么,对于这个连通块来讲,最优的决策(即修改最少)就是这个子图的全部节点数减去这个子图中出现颜色最多的颜色数。这一点不太明白的小伙伴可以看样例画图解决。

思路出来了:

依题意建图,在图上进行深搜,统计每张子图的节点数和出现次数最多的颜色出现了几次,累加答案即可。

于是T到了95感谢出题人@littleseven

一开始我使用了计数数组,每次深搜一张子图我清零一次(memset).

后来我学到了一种叫做(map)的容器,因为这个容器的时间复杂度是(log)级别的,而且它提供的映射操作能够统计题目信息,所以我们选用这个东西来优化实现复杂度/

代码:

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<map>
using namespace std;
const int maxn=2*1e5+10;
int n,m,k,tmp,ans,t;
int tot,head[maxn],nxt[maxn<<1],to[maxn<<1];
bool v[maxn];
map<int,int> mp;
map<int,int>::iterator it;
char *p1,*p2,buf[100000];
#define nc() (p1==p2&&(p2=(p1=buf)+fread(buf,1,100000,stdin),p1==p2)?EOF:*p1++)
int read()
{
    int x=0,f=1;
    char ch=nc();
    while(ch<48){if(ch=='-')f=-1;ch=nc();}
    while(ch>47)    x=(((x<<2)+x)<<1)+ch-48,ch=nc();
    return x*f;
}
int col[maxn];
void add(int x,int y)
{
    to[++tot]=y;
    nxt[tot]=head[x];
    head[x]=tot;
}
void dfs(int x)
{
    v[x]=1;
    mp[col[x]]++;
    tmp++;
    for(int i=head[x];i;i=nxt[i])
    {
        int y=to[i];
        if(v[y])
            continue;
        dfs(y);
    }
}
int main()
{
    n=read(),m=read(),k=read();
    for(int i=1;i<=n;i++)
        col[i]=read();
    for(int i=1;i<=m;i++)
    {
        int x,y;
        x=read();y=read();
        add(x,y);
        add(y,x);
    }
    for(int i=1;i<=n;i++)
        if(!v[i])
        {
            tmp=0,mp.clear(),t=0;
            dfs(i);
            for(it=mp.begin();it!=mp.end();it++)
                t=max(t,it->second);
            ans+=(tmp-t);
        }
    printf("%d",ans);
    return 0;
}
原文地址:https://www.cnblogs.com/fusiwei/p/11797495.html